package example.servlet;

import example.entity.UserCredential;

import javax.persistence.EntityManagerFactory;
import javax.persistence.PersistenceUnit;
import javax.persistence.EntityManager;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.PrintWriter;

public class QueryServlet extends HttpServlet {

    // this injects the default entity manager factory
    @PersistenceUnit(unitName = "pujavaee" )
    private EntityManagerFactory emf;

    public void service ( HttpServletRequest req , HttpServletResponse resp)
        throws ServletException, IOException {


        EntityManager em = emf.createEntityManager();
        try {
            resp.setContentType("text/html");
            PrintWriter out = resp.getWriter();
            out.println("<HTML> <HEAD> <TITLE> Query" +
                        "</TITLE> </HEAD> <BODY BGCOLOR=white>");

            String name = req.getParameter("name");

            // Do a db look up in example.entity.UserCredential table with the name as the PK
            UserCredential credential = em.find(UserCredential.class, name);

            // em.find returns null if not found, hence null check.
            if (credential != null) {
					out.println("<form method=\"post\" action=\"update\">");
					out.println("<p>User Name: " + name);
					out.println("<p><input type=\"hidden\" name=\"name\" value=\"" + name + "\"></p>");
					out.println("<p>User Password: <input type=\"text\" name=\"password\" size=\"10\"> </p>");
					out.println("<p><input type=\"hidden\" name=\"updateAction\" value=\"UPDATE\"></p>");
					out.println("<br>");
					out.println("<p>");
					out.println("<input type=\"submit\" value=\"Update Entity\"/>");
					out.println("</form>");
					
					
					out.println("<form method=\"post\" action=\"update\">");
					out.println("<p><input type=\"hidden\" name=\"name\" value=\"" + name + "\"></p>");
					out.println("<p><input type=\"hidden\" name=\"updateAction\" value=\"DELETE\"></p>");
					out.println("<input type=\"submit\" value=\"Delete Entity\"/>");
					out.println("</form>");
					
            } else {
				out.println("User Name does not exist. Given user name -  " + name);
            }

            out.println("</BODY> </HTML> ");
        } finally {
            // we must close em so that provider can release resources.
            em.close();
        }
    }

    public void  init( ServletConfig config) throws ServletException {
        super.init(config);
//        ServletContext context = config.getServletContext();
//        emf = (EntityManagerFactory) context.getAttribute(ContextListner.ATTRIBUTE_EMF);
//        if(emf == null) {
//            emf = Persistence.createEntityManagerFactory("pu1");
//            context.setAttribute(ContextListner.ATTRIBUTE_EMF, emf);
//
//        }
    }

}

